DAProject/DA.Website/Controllers/CommentController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using DA.Website.Models.CommentModels;
using DA.Website.Models.UserModel;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace DA.Website.Controllers
{
    public class CommentController : Controller
    {
        private const string JSON_MEDIA_TYPE = "application/json";
        private const string AUTHORIZATION_HEADER_NAME = "Authorization";
        private readonly Uri commentUri = new Uri("http://localhost:57868/api/comment");

        // GET:  --------- no need
        public ActionResult Index()
        {
            return View();
        }

        // GET:  ------------ no need
        public ActionResult Details(int id)
        {
            return View();
        }

        
        // GET: Comment/Create  ----------------- Done
        public ActionResult Create(int id)
        {
            CommentEditVM model = new CommentEditVM();
            model.VideoId = id;
            model.OwnerId = LoggedUser.Id;
            return View(model);
        }

       
        // POST: Comment/Create ----------------- Done
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create(CommentEditVM model)
        {
            if (ModelState.IsValid)
            {
                using (HttpClient client = new HttpClient())
                {
                    var token = GetAccessToken();
                    if (string.IsNullOrEmpty(token))
                        return RedirectToAction("Login", "Home");

                    client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                    var serializedContent = JsonConvert.SerializeObject(new { Text = model.Text, VideoId = model.VideoId, OwnerId = model.OwnerId });
                    var stringContent = new StringContent(serializedContent, Encoding.UTF8, JSON_MEDIA_TYPE);

                    HttpResponseMessage response = await client.PostAsync(commentUri, stringContent);
                    if (Auth(response.StatusCode))
                        return RedirectToAction("Login", "Home");

                    if (!response.IsSuccessStatusCode)
                    {
                        return View(model);
                    }
                }
            }
            if (!ModelState.IsValid)
                return View(model);

            return RedirectToAction("Details", "Video", new { id = model.VideoId });
        }
       
        
       
        // GET: Comment/Edit/5 ----------------- Done
        public async Task<ActionResult> Edit(int id)
        {
            using (var client = new HttpClient())
            {

                var token = GetAccessToken();
                if (string.IsNullOrEmpty(token))
                    return RedirectToAction("Login", "Home");

                client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                HttpResponseMessage response = await client.GetAsync($"{commentUri}/{id}");
                if (Auth(response.StatusCode))
                    return RedirectToAction("Login", "Home");

                if (!response.IsSuccessStatusCode)
                {
                    return RedirectToAction(nameof(HomeController.Error), "Home");
                }

                string jsonResponse = await response.Content.ReadAsStringAsync();

                var responseData = JsonConvert.DeserializeObject<CommentEditVM>(jsonResponse);

                return View(responseData);
            }
        }

        
        
        // POST: Comment/Edit/5 ----------------- Done
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(int id, CommentEditVM model)
        {
            if (ModelState.IsValid)
            {
                using (var client = new HttpClient())
                {

                    var token = GetAccessToken();
                    if (string.IsNullOrEmpty(token))
                        return RedirectToAction("Login", "Home");

                    client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                    var serializedContent = JsonConvert.SerializeObject(new { Text = model.Text });
                    var stringContent = new StringContent(serializedContent, Encoding.UTF8, JSON_MEDIA_TYPE);

                    HttpResponseMessage response = await client.PutAsync($"{commentUri}/{id}", stringContent);
                    if (Auth(response.StatusCode))
                        return RedirectToAction("Login", "Home");

                    if (!response.IsSuccessStatusCode)
                    {
                        return RedirectToAction("Error", "Home");
                    }
                }
            }
            if (!ModelState.IsValid)
                return View(model);

            return RedirectToAction("Details", "Video", new { id = model.VideoId });
        }


       
        // POST: Comment/Delete/5 ----------------- Done
        [HttpGet, ActionName("Delete")]
        public async Task<ActionResult> Delete(int id, int videoId)
        {
            using (HttpClient client = new HttpClient())
            {
                Debug.WriteLine(videoId);
                var token = GetAccessToken();
                if (string.IsNullOrEmpty(token))
                    return RedirectToAction("Login", "Home");

                client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                HttpResponseMessage response = await client.DeleteAsync($"{commentUri}/{id}");
                if (Auth(response.StatusCode))
                    return RedirectToAction("Login", "Home");

                if (!response.IsSuccessStatusCode)
                {
                    return RedirectToAction(nameof(HomeController.Error), "Home");
                }
            }

             return RedirectToAction("Details","Video", new { id = videoId });
        }

        private string GetAccessToken()
        {
            var myCookie = Request.Cookies["accessToken"];

            if (!string.IsNullOrEmpty(myCookie))
            {
                return myCookie;
            }
            return null;
        }

        private bool Auth(HttpStatusCode status_code)
        {
            if (status_code == HttpStatusCode.Unauthorized)
            {
                return true;
            }
            return false;
        }
    }
}

DAProject/DA.Website/Controllers/VideoController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Runtime.InteropServices.WindowsRuntime;
using System.Text;
using System.Threading.Tasks;
using DA.Website.Models.UserModel;
using DA.Website.Models.VideoModels;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace DA.Website.Controllers
{
    public class VideoController : Controller
    {
        private const string JSON_MEDIA_TYPE = "application/json";
        private const string AUTHORIZATION_HEADER_NAME = "Authorization";
        private readonly Uri videoUri = new Uri("http://localhost:57868/api/video");
        private readonly Uri loginUri = new Uri("http://localhost:57868/api/login");

        // GET: Video ----------------- Done
        [HttpGet]
        public async Task<ActionResult> Index(string title)
        {
            using (var client = new HttpClient())
            {
                var token =  GetAccessToken();
                if (string.IsNullOrEmpty(token))
                    return RedirectToAction("Login","Home");
               
                client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                HttpResponseMessage response = await client.GetAsync($"{videoUri}?title={title}");

                if (Auth(response.StatusCode))
                    return RedirectToAction("Login", "Home");
                
                if (!response.IsSuccessStatusCode)
                {
                    return RedirectToAction(nameof(HomeController.Error), "Home");
                }

                string jsonResponse = await response.Content.ReadAsStringAsync();

                var responseData = JsonConvert.DeserializeObject<IEnumerable<VideoVM>>(jsonResponse);

                return View(responseData);
            }
        }

        // GET: Video/Details/video1 ----------------- Done
        public async Task<ActionResult> Details(int id)
        {
            using (var client = new HttpClient())
            {

                var token = GetAccessToken();
                if (string.IsNullOrEmpty(token))
                    return RedirectToAction("Login", "Home");

                client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                HttpResponseMessage response = await client.GetAsync($"{videoUri}/{id}");
               
                if (Auth(response.StatusCode))
                    return RedirectToAction("Login", "Home");
               
                if (!response.IsSuccessStatusCode)
                {
                    return RedirectToAction(nameof(HomeController.Error), "Home");
                }

                string jsonResponse = await response.Content.ReadAsStringAsync();

                var responseData = JsonConvert.DeserializeObject<VideoVM>(jsonResponse);

                return View(responseData);
            }
        }

        // GET: Video/Create ----------------- Done
        public ActionResult Create()
        {
            return View();
        }

        // POST: Video/Create ----------------- Done
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create(VideoCreateVM model)
        {
            if (ModelState.IsValid)
            {
                using (HttpClient client = new HttpClient())
                {
                    var token = GetAccessToken();
                    if (string.IsNullOrEmpty(token))
                        return RedirectToAction("Login", "Home");

                    client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                    //That doesn't work unless you log in everytime
                    UserVM curr = new UserVM();
                    curr.Id = LoggedUser.Id;
                    curr.Username = LoggedUser.Username;
                    //----------------------------------------------

                    var serializedContent = JsonConvert.SerializeObject(new { Title = model.Title, Link = model.Link, Over18 = model.Over18, OwnerId = curr.Id});
                    var stringContent = new StringContent(serializedContent, Encoding.UTF8, JSON_MEDIA_TYPE);

                    HttpResponseMessage response = await client.PostAsync(videoUri, stringContent);
                    if (Auth(response.StatusCode))
                        return RedirectToAction("Login", "Home");

                    if (!response.IsSuccessStatusCode)
                    {
                        ModelState.AddModelError("VideoError", "Such video already exists!");
                        return View(model);
                    }
                }
            }
            if (!ModelState.IsValid)
                return View(model);

            return RedirectToAction("Index", "Video");
        }

        // GET: Video/Edit/5 ----------------- Done
        public async Task<ActionResult> Edit(int id)
        {
            using (var client = new HttpClient())
            {

                var token = GetAccessToken();
                if (string.IsNullOrEmpty(token))
                    return RedirectToAction("Login", "Home");

                client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                HttpResponseMessage response = await client.GetAsync($"{videoUri}/{id}");
                if (Auth(response.StatusCode))
                    return RedirectToAction("Login", "Home");

                if (!response.IsSuccessStatusCode)
                {
                    return RedirectToAction(nameof(HomeController.Error), "Home");
                }

                string jsonResponse = await response.Content.ReadAsStringAsync();

                var responseData = JsonConvert.DeserializeObject<VideoCreateVM>(jsonResponse);

                return View(responseData);
            }
        }

        // POST: Video/Edit/5 ----------------- Done
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(VideoCreateVM model)
        {
            if (ModelState.IsValid)
            {
                using (var client = new HttpClient())
                {

                    var token = GetAccessToken();
                    if (string.IsNullOrEmpty(token))
                        return RedirectToAction("Login", "Home");

                    client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                    var serializedContent = JsonConvert.SerializeObject(new { Title = model.Title, Link = model.Link, Over18 = model.Over18});
                    var stringContent = new StringContent(serializedContent, Encoding.UTF8, JSON_MEDIA_TYPE);

                    HttpResponseMessage response = await client.PutAsync($"{videoUri}/{model.Id}", stringContent);
                    if (Auth(response.StatusCode))
                        return RedirectToAction("Login", "Home");

                    if (!response.IsSuccessStatusCode)
                    {
                        ModelState.AddModelError("VideoError", "Such video already exists!");
                        return View(model);
                    }
                }
            }
            if (!ModelState.IsValid)
                return View(model);

            return RedirectToAction("Index", "Video");
        }

        // ----------------- Done
        // check if the video delete will still be processed if HttpGet is removed
        [HttpGet, ActionName("Delete")]
        public async Task<ActionResult> Delete(int id)
        {
            using (HttpClient client = new HttpClient())
            {
                var token = GetAccessToken();
                if (string.IsNullOrEmpty(token))
                    return RedirectToAction("Login", "Home");

                client.DefaultRequestHeaders.Add(AUTHORIZATION_HEADER_NAME, token);

                HttpResponseMessage response = await client.DeleteAsync($"{videoUri}/{id}");
                if (Auth(response.StatusCode))
                    return RedirectToAction("Login", "Home");

                if (!response.IsSuccessStatusCode)
                {
                    return RedirectToAction(nameof(HomeController.Error), "Home");
                }
            }

            return RedirectToAction("Index", "Video");
        }
        
        private string GetAccessToken()
        {
            var myCookie = Request.Cookies["accessToken"];

            if (!string.IsNullOrEmpty(myCookie))
            {
                return myCookie;
            }
            return null;
        }
    
        private bool Auth(HttpStatusCode status_code)
        {
            if (status_code == HttpStatusCode.Unauthorized)
            {
                return true;  
            }
            return false;
        }
    }
}

DAProject/DA.Website/Views/Video/Create.cshtml
@model DA.Website.Models.VideoModels.VideoCreateVM

@{
    ViewData["Title"] = "Create";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Video Create</h1>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Title" class="control-label"></label>
                <input asp-for="Title" class="form-control" />
                <span asp-validation-for="Title" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Link" class="control-label"></label>
                <input asp-for="Link" class="form-control" />
                <span asp-validation-for="Link" class="text-danger"></span>
            </div>
            <div class="form-group">
               @Html.ValidationMessage("VideoError")
            </div>
            <div class="form-group form-check">
                <label class="form-check-label">
                    <input class="form-check-input" asp-for="Over18" /> @Html.DisplayNameFor(model => model.Over18)
                </label>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
        </div>
    </div>

    <div>
        <a asp-action="Index">Back to List</a>
    </div>

DAProject/DA.Website/Views/Video/Details.cshtml
@model DA.Website.Models.VideoModels.VideoVM



@{
    ViewData["Title"] = "Details";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Details</h1>

<div>
      <hr />
      <dl class="row">
          <dt class="col-sm-2">
              @Html.DisplayNameFor(model => model.Title)
          </dt>
          <dd class="col-sm-10">
              @Html.DisplayFor(model => model.Title)
          </dd>
          <dt class="col-sm-2">
              @Html.DisplayNameFor(model => model.Link)
          </dt>
          <dd class="col-sm-10">
              @Html.DisplayFor(model => model.Link)
          </dd>
          <dt class="col-sm-2">
              @Html.DisplayNameFor(model => model.Over18)
          </dt>
           @if (Model.Over18)
            {
              <dd class="col-sm-10">
                  Adult
              </dd>
            }
            else
            {
                <dd class="col-sm-10">
                     All
                </dd>
            }
          
          <dt class="col-sm-2">
              @Html.DisplayNameFor(model => model.Likes)
          </dt>
          <dd class="col-sm-10">
              @Html.DisplayFor(model => model.Likes)
          </dd>
          <dd class="col-sm-2">
              @Html.ActionLink("Leave a comment", "Create", "Comment", new { id = Model.Id })
          </dd>
      </dl>
        <h2>Comments</h2>
        @foreach (var comment in Model.Comments)
        {
    <dl class="row">
            <dt class="col-sm-2">
                @comment.Owner.First_Name<span> </span>@Html.DisplayNameFor(model => comment.Text)
            </dt>
            <dd class="col-sm-10">
                @Html.DisplayFor(model => comment.Text)
            </dd>
            <dt class="col-sm-2">
                @Html.DisplayNameFor(model => comment.Likes)
            </dt>
            <dd class="col-sm-10">
                @Html.DisplayFor(model => comment.Likes)
            </dd>
            <dt class="col-sm-2">
                @Html.DisplayNameFor(model => comment.Dislikes)
            </dt>
            <dd class="col-sm-10">
                @Html.DisplayFor(model => comment.Dislikes)
            </dd>
            @if (comment.Owner.Id == DA.Website.Models.UserModel.LoggedUser.Id)
            {
                <dt>
                    @Html.ActionLink("Edit", "Edit", "Comment", new { id = comment.Id }) 
                </dt>
             }
            @if (Model.Owner.Id == DA.Website.Models.UserModel.LoggedUser.Id)
             {
                <dt>
                    @Html.ActionLink("Delete", "Delete", "Comment", new { id = comment.Id, videoId = comment.VideoId })
                </dt>
             }
    </dl>
         }
</div>
<div>
    <a asp-action="Index">Back to List</a>
</div>

DAProject/DA.Website/Views/Video/Edit.cshtml
@model DA.Website.Models.VideoModels.VideoCreateVM

@{
    ViewData["Title"] = "Edit";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Edit</h1>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input asp-for="Id" type="hidden" class="form-control" />
            <div class="form-group">
                <label asp-for="Title" class="control-label"></label>
                <input asp-for="Title" class="form-control" />
                <span asp-validation-for="Title" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Link" class="control-label"></label>
                <input asp-for="Link" class="form-control" />
                <span asp-validation-for="Link" class="text-danger"></span>
            </div>
            <div class="form-group">
                @Html.ValidationMessage("VideoError")
            </div>
            <div class="form-group form-check">
                <label class="form-check-label">
                    <input class="form-check-input" asp-for="Over18" /> @Html.DisplayNameFor(model => model.Over18)
                </label>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

DAProject/DA.Website/Views/Video/Index.cshtml
@model IEnumerable<DA.Website.Models.VideoModels.VideoVM>
@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>ALl Videos</h1>

@using (Html.BeginForm("Index", "Video", FormMethod.Get))
{
    <table class="table">
        <tr>
            <td> <label class="control-label" style=" font-size:x-large ">Search: </label> </td>
            <td>@Html.TextBox("title", "", new { @class = "form-control", placeholder = "Video Title" })</td>
            <td> <input type="submit" value="Search" class="btn btn-primary" /> </td>
        </tr>
    </table>
}
<p>
    <a asp-action="Create">Create New</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Title)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Owner)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Over18)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.ActionLink(item.Title, "Details", new { id = item.Id })
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Owner.First_Name)
                    @Html.DisplayFor(modelItem => item.Owner.Last_Name)
                </td>
                <td>
                    @if (item.Over18)
                    {
                        <p>Adult</p>
                    }
                    else
                    {
                        <p>All</p>
                    }
                </td>
                <td>
                    @if (item.Owner.Id == DA.Website.Models.UserModel.LoggedUser.Id)
                    {
                        <div>
                            @Html.ActionLink("Delete", "Delete", "Video", new { id = item.Id }) |
                            @Html.ActionLink("Edit", "Edit", new { id = item.Id })
                        </div>
                    }
                </td>
            </tr>
        }

    </tbody>

</table>